/*
**--------------ļϢ----------------------------------------------------------------------------
**   	: CH462EXAM.C
**   	: TECH9 
**޸: 20100712
**		: ʾCH462
**		V1.0			   
**Ӳ  ƽ  ̨MCS51 24MHZ,CH462DM@1106
**--------------------------------------------------------------------------------------------------

****************************************************************************************************/
/*
ʾܣ
1򿪷
2޸ķ
3CH462ʾ0 1 2 3 4 5 6 7 8 9 A b c d E F
ʾйܾCH462DM@1106ʵ
*/
#include "reg52.h"
#include "INTRINS.H"
#include "stdio.H"
#include "CH462INC.H"
#include "CH462HAL.C"

void Delayus(unsigned char i)
{
    while(i--);
}


void Delayms(unsigned char i)
{

    while(i--)
	{
	    Delayus(250);
	    Delayus(250);
	    Delayus(250);
	    Delayus(250);
	}

}

/*==============================================================================
  :  void CH462WriteCMD(unsigned char cmd)

:  CH462룬λǰ3λЧ
  
ӿ˵@input  cmd   룬λЧ

==============================================================================*/

void CH462WriteCMD(unsigned char cmd)
{
    unsigned char i;
	/*cmdλЧλǰ*/
	cmd = cmd << 5;

    CH462_WRN_SET;
	CH462_DATA_OUT;

	for(i = 0; i < 3; i++)
	{
	    CH462_WRN_CLR;                       /*͵ƽʱҪ200ns*/
		/*MCUٶȣٴʱ*/
		if(cmd & 0x80)
		{
		    CH462_DATA_SET;
		}
		else CH462_DATA_CLR;              /*DATAWRؽʱΪ50ns,غ󱣳ʱΪ20ns*/
		/*MCUٶڴʱ*/
		CH462_WRN_SET;                    /*ߵƽʱҪ200ns*/
		cmd = cmd << 1;
		/*MCUٶڴʱ*/
	}    
	CH462_DATA_IN; //ϽDATAΪ״̬
}

/*==============================================================================
  :  void CH462SendConfigOpd( unsigned char pod)

:  CH462ϵͳòλǰ9λݣһλЧ
  
ӿ˵@input  pod   룬9λݣһλЧ

==============================================================================*/

void CH462SendConfigOpd( unsigned char pod)
{
    unsigned char i;

    CH462_WRN_SET;
	CH462_DATA_OUT;

	for(i = 0;i < 9;i++)                 /*ʱ˵οvoid CH462WriteCMD(unsigned char cmd)*/
	{
	    CH462_WRN_CLR;
		if(pod&0x80)
		{
		    CH462_DATA_SET;
		}
		else  CH462_DATA_CLR;
		CH462_WRN_SET;
		pod = pod << 1;
	
	}
	CH462_DATA_IN; 
  
}

/*==============================================================================
  :  void CH462SendRAMAddr( unsigned char ramaddr)

:  CH462RAMַַΧΪ0x00-0x1F
  
ӿ˵@input  ramaddr   RAMַЧλ6λλǰ

==============================================================================*/

void CH462SendRAMAddr( unsigned char ramaddr)
{
    unsigned char i;

    CH462_WRN_SET;
	CH462_DATA_OUT;

	ramaddr = ramaddr << 2;
	for(i = 0;i < 6;i++)                /*ʱ˵οvoid CH462WriteCMD(unsigned char cmd)*/
	{
	    CH462_WRN_CLR;
		if(ramaddr&0x80)
		{
		    CH462_DATA_SET;
		}
		else  CH462_DATA_CLR;
		CH462_WRN_SET;
		ramaddr = ramaddr << 1;
	
	}
    CH462_WRN_SET;
	CH462_DATA_IN; 
}

/*==============================================================================
  :  void CH462SendRAMData( unsigned char mdata)

:  CH462RAM
  
ӿ˵@input  mdata   ҪдRAMݣλǰλЧ

==============================================================================*/

void CH462SendRAMData( unsigned char mdata)
{
    unsigned char i;

    CH462_WRN_SET;
	CH462_DATA_OUT;

	for(i = 0;i < 4;i++)
	{
	    CH462_WRN_CLR;                 /*ʱ˵οvoid CH462WriteCMD(unsigned char cmd)*/
		if(mdata&0x01)
		{
		    CH462_DATA_SET;
		}
		else  CH462_DATA_CLR;
		CH462_WRN_SET;
		mdata = mdata >> 1;
	
	}

    CH462_WRN_SET;
	CH462_DATA_IN; 
}

/*==============================================================================
  :  void CH462ReceiveRAMData( unsigned char *mdata)

:  CH462жȡRAMеݣλǰλЧ
  
ӿ˵@input  *mdata  ָݣλЧ

==============================================================================*/

void CH462ReceiveRAMData( unsigned char *mdata)
{
    unsigned char i;
    unsigned char tmp = 0;
    
    CH462_RDN_SET;
	CH462_DATA_IN; 
	
	for(i = 0;i < 4;i++)
	{
	    CH462_RDN_CLR;                 /*͵ƽʱҪ200ns*/
		CH462_RDN_SET;             
        if(CH462_DATA_S_IN ==1)
		{
        	tmp |= 0x80;
        }
	     tmp >>= 1;
	}
    tmp >>= 3;
    *mdata = tmp;
    CH462_RDN_SET;
	CH462_DATA_IN; 

}


/*==============================================================================
  :  void CH462WriteDisplayRamData(unsigned char disdata, unsigned char addr)

:  ָRAMַдݡ1д 2дַ3д
              
ӿ˵@input  disdata  д
                  addr     RAMַ
==============================================================================*/

void CH462WriteDisplayRamData(unsigned char disdata, unsigned char addr)
{
	CH462_CSN = 1;
	CH462_CSN = 0;
/*step1 send  CMD_LCD_WRITE*/
    CH462WriteCMD(CMD_LCD_WRITE);
/*step2 send  RAM ADDR*/
	CH462SendRAMAddr(addr);
/*step3 send  RAM DATA*/
    CH462SendRAMData(disdata);

	CH462_CSN = 1;
}

/*==============================================================================
  :  void CH462ReadDisplayRamData(unsigned char *disdata, unsigned char addr)

:  ָRAMַжݡ1д 2дַ3
              
ӿ˵@input  *disdata  дdisdata
                  addr     RAMַ
==============================================================================*/

void CH462ReadDisplayRamData(unsigned char *disdata, unsigned char addr)
{
	CH462_CSN = 1;
	CH462_CSN = 0;
/*step1 send  CMD_LCD_WRITE*/
    CH462WriteCMD(CMD_LCD_READ);
/*step2 send  RAM ADDR*/
	CH462SendRAMAddr(addr);
/*step3 read  RAM DATA*/
    CH462ReceiveRAMData(disdata);

	CH462_CSN = 1;
}

/*API*/
/*==============================================================================
  :  void CH462DisableBeep(void)

:  رշ 
              
ӿ˵                  

==============================================================================*/

void CH462DisableBeep(void)
{
	CH462_CSN = 0;
    CH462WriteCMD(CMD_SYS_CONFIG);
	CH462SendConfigOpd(OPD_BZ_OFF);
	CH462_CSN = 1;
}

/*==============================================================================
  :  void CH462EnableBeep(void)

:   
              
ӿ˵                  

==============================================================================*/


void CH462EnableBeep(void)
{
	CH462_CSN = 0;
    CH462WriteCMD(CMD_SYS_CONFIG);
	CH462SendConfigOpd(OPD_BZ_ON);
	CH462_CSN = 1;
}


/*==============================================================================
  :  void CH462DisableLcdDisplay(void)

:  رLCDʾ 
              
ӿ˵                  

==============================================================================*/


void CH462DisableLcdDisplay(void)
{
	CH462_CSN = 0;
    CH462WriteCMD(CMD_SYS_CONFIG);
	CH462SendConfigOpd(OPD_LCD_OFF);
	CH462_CSN = 1;
}


/*==============================================================================
  :  void CH462EnableLcdDisplay(void)

:  LCDʾ
              
ӿ˵                  

==============================================================================*/

void CH462EnableLcdDisplay(void)
{
	CH462_CSN = 0;
    CH462WriteCMD(CMD_SYS_CONFIG);
	CH462SendConfigOpd(OPD_LCD_ON);
	CH462_CSN = 1;
}

/*==============================================================================
  :  void CH462SetLcdPar(unsigned char lcdpar)

:  LCD
              
ӿ˵@input lcdpar   LCD
                           OPD_BIAS2_2COMSOPD_BIAS2_3COMSOPD_BIAS2_4COMS
                           OPD_BIAS3_2COMSOPD_BIAS3_3COMSOPD_BIAS3_4COMS

==============================================================================*/

void CH462SetLcdPar(unsigned char lcdpar)
{
	CH462_CSN = 0;
    CH462WriteCMD(CMD_SYS_CONFIG);
	CH462SendConfigOpd(lcdpar);
	CH462_CSN = 1;
}

/*==============================================================================
  :  void CH462EnablePLL(void)

:  ϵĬΪرգ 
              
ӿ˵                  

==============================================================================*/

void CH462EnablePLL(void)
{
	CH462_CSN = 0;
    CH462WriteCMD(CMD_SYS_CONFIG);
	CH462SendConfigOpd(OPD_SYS_ON);
	CH462_CSN = 1;
}


/*==============================================================================
  :  void CH462DisablePLL(void)

:  ر͹ģʽϵĬΪر
              
ӿ˵                  

==============================================================================*/

void CH462DisablePLL(void)
{
	CH462_CSN = 0;
    CH462WriteCMD(CMD_SYS_CONFIG);
	CH462SendConfigOpd(OPD_SYS_OFF);
	CH462_CSN = 1;
}
/*==============================================================================
  :  void CH462ModifyBeepFre(unsigned char beepfre )

:  ڷƵ 
              
ӿ˵ @input  beepfre δ⣬ֻ
                           OPD_BZ_4KHZ  OPD_BZ_2KHZ                  

==============================================================================*/

void CH462ModifyBeepFre(unsigned char beepfre )
{
	CH462_CSN = 0;
    CH462WriteCMD(CMD_SYS_CONFIG);
	CH462SendConfigOpd(beepfre);
	CH462_CSN = 1;
}



/*==============================================================================
  :  unsigned char ASCIISwitchToHex(unsigned char dischar)

:  ַתΪֱCH462RAM16ݣֻת
           '0'~'9','A','b','c','d','E','F'δԲڴݽм⣬û
           ԸLCDŲת
              
ӿ˵ @input  dischar Ҫʾַ
           @output         תϵ                  

==============================================================================*/

unsigned char ASCIISwitchToHex(unsigned char dischar)
{
   unsigned char i;
   
   switch(dischar)
   {
       case '1':
	   i = 0x60;
	   break;
       case '2':
	   i = 0x3e;
	   break;
       case '3':
	   i = 0x7a;
	   break;
       case '4':
	   i = 0x63;
	   break;
       case '5':
	   i = 0x5b;
	   break;
       case '6':
	   i = 0x5f;
	   break;
       case '7':
	   i = 0x70;
	   break;
       case '8':
	   i = 0x7f;
	   break;
       case '9':
	   i = 0x7b;
	   break;
       case '0':
	   i = 0x7d;
	   break;
       case 'A':
	   i = 0x77;
	   break;
       case 'b':
	   i = 0x4f;
	   break;
       case 'c':
	   i = 0x0e;
	   break;
       case 'd':
	   i = 0x6e;
	   break;
       case 'E':
	   i = 0x1f;
	   break;
       case 'F':
	   i = 0x17;
	   break;
       default:
       break;
   
   
   }
   return i;
}

/*==============================================================================
  :  void CH462PrintChar(unsigned char dischar,unsigned char lcdaddr)

:  ָLCDλʾַLCDʾλӰ죬û޸
              
ӿ˵ @input  dischar Ҫʾַ
           @input  lcdaddr LCDλ                  

==============================================================================*/

void CH462PrintChar(unsigned char dischar,unsigned char lcdaddr)
{
    unsigned char i;
    if(lcdaddr > 15)return;
    
    lcdaddr = lcdaddr * 2;
    
    i = ASCIISwitchToHex(dischar);
    
    CH462WriteDisplayRamData(i,lcdaddr);
    
    CH462WriteDisplayRamData(i>>4,lcdaddr+1);
}





/*MCUŷ*/
/*
WRN,RDN,CSN򣬲ҳʼΪߵƽ

*/
void  CH462PortInit(void)
{
	 CH462_DATA_SET;
	 CH462_WRN_SET;
	 CH462_RDN_SET;
	 CH462_CSN_SET;
	 CH462_WRN_OUT;
	 CH462_RDN_OUT;
	 CH462_CSN_OUT;

}

main( )
{
    unsigned char i;

	Delayms(200);
	Delayms(200);

	CH462PortInit( );                  /*MCUӿڳʼ*/

    CH462EnablePLL( );  			   /**/
    CH462ModifyBeepFre(OPD_BZ_4KHZ);   /*÷4KHZ*/
    CH462EnableBeep( );				   /*򿪷*/
    CH462SetLcdPar(OPD_BIAS3_4COMS);   /*LCDΪOPD_BIAS3_4COMS*/

	for(i = 0;i < 32;i++ )CH462WriteDisplayRamData(0x00,i);	/*LCD RAM*/


	 CH462PrintChar('0',0);	           /*ʾ'1'-'F'*/
	 CH462PrintChar('1',1);
	 CH462PrintChar('2',2);
	 CH462PrintChar('3',3);
	 CH462PrintChar('4',4);
	 CH462PrintChar('5',5);
	 CH462PrintChar('6',6);
	 CH462PrintChar('7',7);
	 CH462PrintChar('8',8);
	 CH462PrintChar('9',9);
	 CH462PrintChar('A',10);
	 CH462PrintChar('b',11);
	 CH462PrintChar('c',12);
	 CH462PrintChar('d',13);
	 CH462PrintChar('E',14);
	 CH462PrintChar('F',15);
     CH462EnableLcdDisplay( );		     /*ʾ*/
	 Delayms(200);
	 Delayms(200);
	 Delayms(200);
     CH462DisableBeep( );		         /*رշ*/
     while(1)
	 {
	     CH462EnableLcdDisplay( );       /*LCD*/
		 CH462EnableBeep( );
		 Delayms(200);
		 Delayms(200);
		 CH462DisableLcdDisplay( );
		 CH462DisableBeep( );
		 Delayms(200);
		 Delayms(200);
	 }	 

    while(1);	
}
